#include "libsock5.h"
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>

#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>

#include <netdb.h>

int TryConnect(char *phost, int port) {
    struct hostent *hp;
    struct sockaddr_in ssin;
    int sd;
    char buf[512];
    fd_set fds;

    memset((char *)&ssin, 0, sizeof(struct sockaddr_in));
    ssin.sin_family      = AF_INET;
    ssin.sin_port        = htons(port);
    if ((hp = gethostbyname(phost)) != NULL)
        memcpy(&(ssin.sin_addr.s_addr), (char *)hp->h_addr_list[0], 4);
    else if ((ssin.sin_addr.s_addr = inet_addr(phost))==-1) return -1;

    if ((sd = socket(AF_INET, SOCK_STREAM, 0)) < 0) return -1;
    if (connect(sd, (struct sockaddr *)&ssin, sizeof(ssin)) < 0) return -1;

    strcpy(buf, "xxxxxxxxxxxxxxx\n\0");
    send(sd, buf, strlen(buf), 0);

    FD_ZERO(&fds);
    FD_SET(sd, &fds);
    if (select(sd+1, &fds, NULL, NULL, NULL) < 0) return -1;

    bzero(buf, 512);
    recv(sd, buf, 512, 0);

    printf("%s\n", buf);

    soclose(sd);

    return 0;
}

int main(int argc, char **argv) {

    if (argc != 3) {
	fprintf(stderr, "usage: mycon host port\n");
        exit(0);
    }

    sock_init();
    TryConnect(argv[1], atoi(argv[2]));

    return 0;
}
